/*
I2C 
2022.3.16 ɾҪĴ룬ĸOLED
*/

#include "n32g430.h"
//#include "ME_TYPE.h"
#include "i2c.h"
#include "oled_ascii.h"

#define oled_12864

u8 oled_buff[128][8];
u8 font_buff[30];

void i2c_delay_times(u32 times)
{
	//	while(times--);
}

void i2c_delay_ms(u32 times)
{
	times=times*740*5;
	while(times--);
}

void i2c_init(void)
{ 
	I2C_RST_L();
	i2c_delay_times(50000);
	I2C_RST_H();
	i2c_delay_times(5000);
	
	SCL_H();
	SDA_H();
	
}

void i2c_free(void)
{
			SCL_H();
			SDA_H();
			i2c_delay_times(i2c_delay);
}

void i2c_start(void)
{
		SCL_H();
		SDA_H();
		i2c_delay_times(i2c_delay);
	
		SDA_L();
		i2c_delay_times(i2c_delay);
	
		SCL_L();
		i2c_delay_times(i2c_delay);
}

void i2c_stop(void)
{
		SCL_L();//must   when scl is low 
		i2c_delay_times(i2c_delay);
		SDA_L();
		i2c_delay_times(i2c_delay);
		SCL_H();
		i2c_delay_times(i2c_delay);
		SDA_H();
		i2c_delay_times(i2c_delay);

}

void i2c_write_data(u8 temp)
{
		u8 i;
		for(i=0;i<8;i++)
		{
			SCL_L();//when sck is low  ,data can change
			i2c_delay_times(i2c_delay);
			
			if((temp&0x80)==0x80)
			SDA_H();
			else
			SDA_L();	
			
			i2c_delay_times(i2c_delay);
			
			SCL_H();
			i2c_delay_times(i2c_delay);
		
			temp=temp<<1;
			
			SCL_L();
		}
		SDA_H();
}


u8 i2c_read_data(void)
{
		u8 i,temp;

		SDA_H();
		for(i=0;i<8;i++)
		{
			temp=temp<<1;
			
			SCL_L();
			i2c_delay_times(i2c_delay);
			SCL_H();
			i2c_delay_times(i2c_delay);
			
			if(SDA_STAT()!=0)//if(SDA_STAT()==1)
			temp=temp|0x01;
			else
			;
			
			i2c_delay_times(i2c_delay);
			
			SCL_L();
			
		}
			
		return temp;
	
}
	
void i2c_ack(void)
{

		SCL_L();
		i2c_delay_times(i2c_delay);
	
		SDA_L();
		i2c_delay_times(i2c_delay);
	
		SCL_H();
		i2c_delay_times(i2c_delay);
		SCL_L();
		i2c_delay_times(i2c_delay);
	
}
	
void i2c_nack(void)
{
		SCL_L();
		i2c_delay_times(i2c_delay);
	
		SDA_H();
		i2c_delay_times(i2c_delay);
	
		SCL_H();
		i2c_delay_times(i2c_delay);
		SCL_L();
		i2c_delay_times(i2c_delay);
}

u8 i2c_waitack(void)
{
		u8 temp;
	
		SCL_L();

		i2c_delay_times(i2c_delay);
		SDA_H();
		i2c_delay_times(i2c_delay);
	
		SCL_H();
		i2c_delay_times(i2c_delay);
	
		if(SDA_STAT()==0)
			temp=0x01;//suss
		else
			temp=0x00;
	
		SCL_L();

	
	return temp;
}
	

u8 text_i2c_address(u8 address)
{			
			u8 pass;
			i2c_start();
			i2c_write_data(address);
			pass=i2c_waitack();//0x01 pass  0x00 NG
			i2c_stop();
			return pass;
}

//--------------EEPROM----24C02--------------------------
u8 read_eeprom(u8 address)  //a0 a1   
{
			u8 temp;
			i2c_start();
			i2c_write_data(0xa0);
			i2c_waitack();
			i2c_write_data(address);
			i2c_waitack();
	
			i2c_start();
			i2c_write_data(0xa1);
			i2c_waitack();
			temp=i2c_read_data();
			i2c_nack();
			i2c_stop();
	
			return temp;

}

void write_eeprom(u8 address,u8 temp)
{
			i2c_start();
			i2c_write_data(0xa0);
			i2c_waitack();
			i2c_write_data(address);
			i2c_waitack();
			i2c_write_data(temp);
			i2c_waitack();
			i2c_stop();

}

//---------------OLED------------------------------------2021.10.23 Ż

//0x00 comm   0x40  data
void write_oled_12864(u8 temp,u8 address)
{		

			i2c_start();
			i2c_write_data(0x78);
			i2c_waitack();
			i2c_write_data(address);
			i2c_waitack();
			i2c_write_data(temp);
			i2c_waitack();
			i2c_stop();
}

void reset_oled_12864(void)
{
	SCL_H();
	SDA_H();

	I2C_RST_L();
	i2c_delay_ms(500);
	I2C_RST_H();
	i2c_delay_ms(100);
}


void init_oled_12864(u8 angle)
{

	write_oled_12864(0xe3,0x00);
	write_oled_12864(0xae,0x00);
	
	write_oled_12864(0xd5,0x00);
	write_oled_12864(0x80,0x00);
	
	write_oled_12864(0xa8,0x00);
	write_oled_12864(0x3f,0x00);
	
	write_oled_12864(0xd3,0x00);
	write_oled_12864(0x00,0x00);
	
	write_oled_12864(0x40,0x00);
	
	write_oled_12864(0x8d,0x00);
	write_oled_12864(0x14,0x00);
	
	write_oled_12864(0x14,0x00);
	write_oled_12864(0x20,0x00);
	
	write_oled_12864(0x02,0x00);	
	write_oled_12864(0xa0,0x00);
	
	write_oled_12864(0xc0,0x00);
	write_oled_12864(0xda,0x00);
	
	write_oled_12864(0x12,0x00);
	write_oled_12864(0x81,0x00);
	
	write_oled_12864(0x55,0x00);
	write_oled_12864(0xd9,0x00);
	
	write_oled_12864(0xf1,0x00);
	write_oled_12864(0xdb,0x00);
	
	write_oled_12864(0x40,0x00);
	write_oled_12864(0xa4,0x00);
	write_oled_12864(0xa6,0x00);
	write_oled_12864(0xad,0x00);
	write_oled_12864(0x30,0x00);
	

	
	write_oled_12864(0x00,0x00);	//õеַ
	write_oled_12864(0x10,0x00);	//øеַ
	write_oled_12864(0x40,0x00);	//ʼеַ
	write_oled_12864(0xB0,0x00);	//ҳַ
	
	if(angle==1)
	{
		write_oled_12864(0xA1,0x00);	//öΣSEGʼӳַcolumn127ַSEG0ĵַ
		write_oled_12864(0xA6,0x00);	//ʾ0xa7ʾ
		write_oled_12864(0xC8,0x00);	//ӳģʽCOM[N-1]~COM0ɨ
	}
	else if(angle==2)
	{
		write_oled_12864(0xA0,0x00);	
		write_oled_12864(0xA6,0x00);	
		write_oled_12864(0xC0,0x00);	
	}
	else if(angle==3)
	{
		write_oled_12864(0xA1,0x00);	
		write_oled_12864(0xA6,0x00);
		write_oled_12864(0xC8,0x00);
	}
	else if(angle==4)
	{
		write_oled_12864(0xA1,0x00);	
		write_oled_12864(0xA6,0x00);	
		write_oled_12864(0xC8,0x00);
	}
	else
	{
		write_oled_12864(0xA1,0x00);	
		write_oled_12864(0xA6,0x00);	
		write_oled_12864(0xC8,0x00);	
	}

	

	
	write_oled_12864(0xaf,0x00);

	i2c_delay_times(5000);

}


void clear_oled_12864(u8 colour)
{
	u16 i,j;
	for(i=0;i<8;i++) 
	{
			write_oled_12864 (0xb0+i,0x00);    //0~7ҳд
			write_oled_12864 (0x00,0x00);      //е͵ַ
			write_oled_12864 (0x10,0x00);      //иߵַ  
			for(j=0;j<128;j++)
			{
				write_oled_12864(colour,0x40); //д 0 
			}
	}
}


void bmp_oled_12864(const u8 *table)//д128*64ɫͼƬ
{
	u16 i,j;
	for(i=0;i<8;i++) 
	{
			write_oled_12864(0xb0+i,0x00);    //0~7ҳд
			write_oled_12864(0x00,0x00);      //е͵ַ
			write_oled_12864(0x10,0x00);      //иߵַ  
		
			i2c_start();
			i2c_write_data(0x78);
			i2c_waitack();
			i2c_write_data(0x40);
			i2c_waitack();
			for(j=0;j<128;j++)
			{		
					i2c_write_data(table[j+i*128]);
					i2c_waitack();
			}

			i2c_stop();
	}
}




void front8_oled_12864(u8 x,u8 y,u8 data,u8 colour)
{
	u16 i;
	u8 x_lbyte,x_hbyte;
	
	x=x*8;
	x_lbyte=x;
	x_lbyte=x_lbyte<<4;
	x_lbyte=x_lbyte>>4;
	
	x_hbyte=x;
	x_hbyte=x_hbyte>>4;
	
	write_oled_12864 (0xb0+y,0x00);    
	write_oled_12864 (0x00+x_lbyte,0x00);      
	write_oled_12864 (0x10+x_hbyte,0x00);  
	if(colour==0)//
	{
		for(i=0;i<5;i++)
			write_oled_12864(font_5_8[data][i],0x40); 
		
			write_oled_12864(0x00,0x40); 
			write_oled_12864(0x00,0x40); 
			write_oled_12864(0x00,0x40); 
	}
	else
	{
			for(i=0;i<5;i++)
			write_oled_12864(~font_5_8[data][i],0x40); 
		
			write_oled_12864(0xFF,0x40); 
			write_oled_12864(0xFF,0x40); 
			write_oled_12864(0xFF,0x40); 
	}
}

void front16_oled_12864(u8 x,u8 y,u8 data,u8 colour)
{
	u16 i;
	u8 x_lbyte,x_hbyte;
	
	x=x*8;
	x_lbyte=x;
	x_lbyte=x_lbyte<<4;
	x_lbyte=x_lbyte>>4;
	
	x_hbyte=x;
	x_hbyte=x_hbyte>>4;
	
	y=y*2;
	
	write_oled_12864 (0xb0+y,0x00);    
	write_oled_12864 (0x00+x_lbyte,0x00);      
	write_oled_12864 (0x10+x_hbyte,0x00);      
	if(colour==0)//
	{
		for(i=0;i<8;i++)
			write_oled_12864(font_8_16[data][i],0x40); 
	}
	else 
	{
		for(i=0;i<8;i++)
			write_oled_12864(~font_8_16[data][i],0x40); 
	}
	
	write_oled_12864 (0xb0+y+1,0x00);    
	write_oled_12864 (0x00+x_lbyte,0x00);     
	write_oled_12864 (0x10+x_hbyte,0x00);     
	if(colour==0)//
	{
		for(i=0;i<8;i++)
			write_oled_12864(font_8_16[data][i+8],0x40); 
	}
	else
	{
		for(i=0;i<8;i++)
			write_oled_12864(~font_8_16[data][i+8],0x40); 
	}

}


void front16_16_oled_12864(u8 x,u8 y,u8 data,u8 colour)
{
	u16 i;
	u8 x_lbyte,x_hbyte;
	
	x=x*16;
	x_lbyte=x;
	x_lbyte=x_lbyte<<4;
	x_lbyte=x_lbyte>>4;
	
	x_hbyte=x;
	x_hbyte=x_hbyte>>4;
	
	y=y*2;
	
	write_oled_12864 (0xb0+y,0x00);   
	write_oled_12864 (0x00+x_lbyte,0x00);     
	write_oled_12864 (0x10+x_hbyte,0x00);      
	if(colour==0)
	{
		for(i=0;i<16;i++)
			write_oled_12864(font_16_16[data][i],0x40);
	}
	else
	{
		for(i=0;i<16;i++)
			write_oled_12864(~font_16_16[data][i],0x40);
	}


	write_oled_12864 (0xb0+y+1,0x00);   
	write_oled_12864 (0x00+x_lbyte,0x00);    
	write_oled_12864 (0x10+x_hbyte,0x00);    
	if(colour==0)
	{
		for(i=0;i<16;i++)
			write_oled_12864(font_16_16[data][i+16],0x40); 
	}
	else
	{
		for(i=0;i<16;i++)
			write_oled_12864(~font_16_16[data][i+16],0x40); 
	}

}

void front16_32_oled_12864(u8 x,u8 y,u8 data,u8 colour)//2021.8.2 Ż
{
	u16 i;
	u8 x_lbyte,x_hbyte;
	
//	x=x*16;
	x=x*8;//2022.4.18 ʹ8Ϊ࣬ΪƥС㡣
	x_lbyte=x;
	x_lbyte=x_lbyte<<4;
	x_lbyte=x_lbyte>>4;
	
	x_hbyte=x;
	x_hbyte=x_hbyte>>4;
	
	y=y*2;
	
	write_oled_12864 (0xb0+y,0x00);    //0~7ҳд  8*8
	write_oled_12864 (0x00+x_lbyte,0x00);      //е͵ַ
	write_oled_12864 (0x10+x_hbyte,0x00);      //иߵַ  
	if(colour==0)
	{
		for(i=0;i<16;i++)
			write_oled_12864(font_16_32[data][i],0x40); //д һҳ(8Ϊһҳ)16(8bit)
	}
	else
	{
		for(i=0;i<16;i++)
			write_oled_12864(~font_16_32[data][i],0x40); //д һҳ(8Ϊһҳ)16(8bit)
	}


	write_oled_12864 (0xb0+y+1,0x00);   
	write_oled_12864 (0x00+x_lbyte,0x00);      
	write_oled_12864 (0x10+x_hbyte,0x00);    
	if(colour==0)
	{
		for(i=0;i<16;i++)
			write_oled_12864(font_16_32[data][i+16],0x40); 
	}
	else
	{
		for(i=0;i<16;i++)
			write_oled_12864(~font_16_32[data][i+16],0x40); 
	}	

		
	write_oled_12864 (0xb0+y+2,0x00);   
	write_oled_12864 (0x00+x_lbyte,0x00);      
	write_oled_12864 (0x10+x_hbyte,0x00);   
	if(colour==0)
	{
		for(i=0;i<16;i++)
			write_oled_12864(font_16_32[data][i+32],0x40); 
	}
	else
	{
		for(i=0;i<16;i++)
			write_oled_12864(~font_16_32[data][i+32],0x40); 
	}	


	write_oled_12864 (0xb0+y+3,0x00);    
	write_oled_12864 (0x00+x_lbyte,0x00);     
	write_oled_12864 (0x10+x_hbyte,0x00);    
	if(colour==0)
	{
		for(i=0;i<16;i++)
			write_oled_12864(font_16_32[data][i+48],0x40); 
	}
	else
	{
		for(i=0;i<16;i++)
			write_oled_12864(~font_16_32[data][i+48],0x40); 
	}	
	
}

void clear_oled_buff(void)
{
		u8 i,j;
	for(i=0;i<128;i++)
	{
			for(j=0;j<8;j++)
			{
				oled_buff[i][j]=0;
			}
	}
}
//buff㺯 2021.3.13
void write_point_oled(u8 x,u8 y)
{

	u8 temp_table[8]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
	u8 temp;
	u8 old_data;
//	u16 i;
	u8 x_lbyte,x_hbyte;
	
	x_lbyte=x;
	x_lbyte=x_lbyte<<4;
	x_lbyte=x_lbyte>>4;
	
	x_hbyte=x;
	x_hbyte=x_hbyte>>4;
	

	old_data=oled_buff[x][y/8];//ȡ
	
	temp=temp_table[y%8];
	temp=temp|old_data;
	
	oled_buff[x][y/8]=temp;//д뻺
	
	y=y/8;
	
	write_oled_12864 (0xb0+y,0x00);    //0~7ҳд  
	write_oled_12864 (0x00+x_lbyte,0x00);      //е͵ַ
	write_oled_12864 (0x10+x_hbyte,0x00);      //иߵַ  

	write_oled_12864(temp,0x40); //д 
	
}
//buff㺯 2021.3.13
void clear_point_oled(u8 x,u8 y)
{

	u8 temp_table[8]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
	u8 temp;
	u8 old_data;
//	u16 i;
	u8 x_lbyte,x_hbyte;
	
	x_lbyte=x;
	x_lbyte=x_lbyte<<4;
	x_lbyte=x_lbyte>>4;
	
	x_hbyte=x;
	x_hbyte=x_hbyte>>4;
	

	old_data=oled_buff[x][y/8];//ȡ
	
	temp=temp_table[y%8];//ȡ
	
	temp=(0xff-temp)&old_data;
	
	oled_buff[x][y/8]=temp;//д뻺
	
	y=y/8;
	
	write_oled_12864 (0xb0+y,0x00);    //0~7ҳд  
	write_oled_12864 (0x00+x_lbyte,0x00);      //е͵ַ
	write_oled_12864 (0x10+x_hbyte,0x00);      //иߵַ  

	write_oled_12864(temp,0x40); //д 
}


//----------2022.3.16 Ӳֲ----------------------------------
//ASCII "0"= 48 = 0x30
//ASCII " "= 32 = 0x20
/*
u16 x               ʼX
u16 y								ʼY
u8  colour			    ԣ
u8 font_sum					
u8 *font_data				 ASCIIַ
*/

void LCD_print_8(u16 x,u16 y,u8 colour,u8 font_sum,char *font_data)
{
	u8 i;

	for(i=0;i<font_sum;i++)
	{
		front8_oled_12864(x+i,y,font_data[i]-0x20,colour);
	}
	
}

void LCD_print_16(u16 x,u16 y,u8 colour,u8 font_sum,char *font_data)
{
	u8 i;

	for(i=0;i<font_sum;i++)
	{
		front16_oled_12864(x+i,y,font_data[i]-0x20,colour);
	}
	
}

void LCD_print_16_16(u16 x,u16 y,u8 colour,u8 font_sum,char *font_data)
{
	u8 i;

	for(i=0;i<font_sum;i++)
	{
		front16_16_oled_12864(x+i,y,font_data[i]-0x30,colour);
	}
	
}

//2022.4.18 ˼ xΪ8Ϊ С
void LCD_print_16_32(u16 x,u16 y,u8 colour,u8 font_sum,char *font_data)
{
	u8 i;

	for(i=0;i<font_sum;i++)
	{
		front16_32_oled_12864((x+i*2),y,font_data[i]-0x30,colour);//(x+i*2) 
	}
	
}

//--------------------------------ina226 2021.3.13---------------------
u16 read_ina226(u8 address)
{
			u16 temp;
			u8 temp_l,temp_h;
	
			i2c_start();
			i2c_write_data(0x80);
			i2c_waitack();
			i2c_write_data(address);
			i2c_waitack();
	
			i2c_start();
			i2c_write_data(0x81);
			i2c_waitack();
			temp_h=i2c_read_data();
			i2c_ack();
			temp_l=i2c_read_data();
			i2c_nack();
			i2c_stop();
	
			temp=temp_h;
			temp=temp<<8;
			temp=temp+temp_l;
	
			return temp;
	

}

void write_ina226(u8 address,u16 temp)
{
			u8 temp_l,temp_h;
			temp_l=temp;
			temp_h=temp>>8;
	
			i2c_start();
			i2c_write_data(0x80);
			i2c_waitack();
			i2c_write_data(address);
			i2c_waitack();
			i2c_write_data(temp_h);
			i2c_waitack();
			i2c_write_data(temp_l);
			i2c_waitack();
			i2c_stop();

}
void init_ina226(void)
{
		write_ina226(0x05,512);//CalibrationRegister
}

u8 read_back_init_ina226(void)//֤Ƿ 0 OK  1 error
{
		u16 temp;
		temp=read_ina226(0x05);
		if(temp==512)
		return 0;
		else
		return 1;
}
//--------------------------------------------------------------------

